      SUBROUTINE DERNON(N,I,L)
C  CALLED BY SOLVE OR CALCUS WHENEVER ATOM N IS AN "AFFECTED ATOM" OF
C            SOME ATTACHED RIGID GROUP (ARG; FORMERLY "NON-RIGID GROUP")
C     CALCULATE DERIVATIVES FOR NON-RIGID BODY PARAMETERS
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTOT
     1,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/LOCC/ATNX(7,2), BLLARG(7)
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(15,3)
      DIMENSION AO(80),IZ(5),NRBP(150),IPAIR(7,7), NAFA(15), NONSY(15)
      EQUIVALENCE (IZ(1),IAIDX1(801)),(IPAIR(1,1),AIDX(1701))
      EQUIVALENCE (NRBP(1),IAIDX1(850))
      EQUIVALENCE (AO(1),AIDX(1041)), (IAIDX1(1000),IGN)
      EQUIVALENCE (NAFA(1), IAIDX1(766)),(NONSY(1), IAIDX1(601))
      CHARACTER*4 ATNX,NAME1, ATNAME, TISET, TITLE*80, ITBL*3, NAME2*5
C
      NHP1 = NP1 + 1
C ***   NP1 = 12 (IF PT GROUP IS CENTROSYMMETRIC) OR 21
      J1 = 0
      NN = NRBP(N)
      DO 5 J = 1,5
      IH = NN/16
      IZ(J) = NN - 16*IH
      IF(IZ(J).EQ.0)  GO TO 10
      NN = IH
      J1 = J1 + 1
    5 CONTINUE
C ***   DERNON NOT EVEN CALLED UNLESS ATOM IS IN AT LEAST ONE N-R GROUP
C ***  J1 = NO OF NON RIGID GROUPS THIS ATOM IS IN
C ***  IZ(I) [FOR I = 1,J1] ARE SERIAL NOS OF N-R GROUPS THIS ATOM IS IN
C ***   NNP1 = TOTAL NUMBER OF PARAMETERS (SET IN SOLVE)
C ***
C ***  UNIT VECTORS FOR LOCAL AXIAL SYSTEM FOR EACH GROUP, I, WILL BE:
C ***     VEC1(I,J)   VECTOR PARALLEL TO LIBRATION AXIS
C ***     VAF(I,J)   VECTOR PARALLEL TO MOTION OF 1ST AFFECTED ATOM
C ***     PVEC(I,J)   UNIT VECTOR NORMAL TO FIRST TWO
C ***   VEC1 COMES FROM SUBR DERNOP, THE OTHER TWO FROM SUBR LOCAL
   10 DO 15 I1 = NHP1,NNP1
      AO(I1) = 0.
   15 CONTINUE
      DO 20 K = 1,J1
C   IGN SET = M BY DERNP IF ATOM N IN NR GROUP M LIES ON AXIS OF
C     THIS GROUP ALTHOUGH SAID TO BE AFFECTED BY THE MOTION
      M = IZ(K)
C ***  SKIP ATOM IF IT LIES ON AXIS OF GROUP (NOT AFFECTED BY MOTION)
      IF(IGN.EQ.M) GO TO 20
C *** FOLLOWING FOUR LINES ADDED, STATEMENT BEFORE 20 ADDED, 24.IX.85
C ***     AND COMMENTED OUT 5.I.86
C ***   I AND L ARE INDICES (1, 2, OR 3) IN THE CALLING STATEMENT
C     II2 = MOD(I,3) + 1
C     II3 = MOD(II2,3) + 1
C     LL2 = MOD(L,3) + 1
C     LL3 = MOD(LL2,3) + 1
      AO(NP1+M) = V5(M,I)*V5(M,L)
C     IF(ICORL.GE.0) AO(NP1+M) = AO(NP1+M)+
C    1    0.5*V5(M,I)*(VEC1(M,LL2)*AX(N,LL3)
C    2 - VEC1(M,LL3)*AX(N,LL2)) + 0.5*V5(M,L)*(VEC1(M,II2)*AX(N,II3)
C    3   - VEC1(M,II3)*AX(N,II2))
   20 CONTINUE
      IF(ICORL.LT.0.OR.(NAFA(M).LT.2.AND.NONSY(M).NE.0)) GO TO 76
C *** CALCULATE CORRELATION OF PHI AND OVERALL MOTION
C ***     (UNLESS ICORL.LT.0 OR ONLY ONE ATOM IN THE ARG, NOT ON A SYM ELEM)
C ***  CALC MADE IN EACH LOCAL SYSTEM; PHI-LAMBDA PARALLEL TO AXIS IS
C ***   IGNORED, SO ONLY FIVE ADDED PARAMETERS PER GROUP
      NNP2 = NP1 + NONRIG
      DO 75 MM = 1,J1
      M = IZ(MM)
C ***  M = SERIAL NUMBER OF NON-RIGID GROUP
      K = NNP2 + 5*(M-1)
C ***  THUS K = NNP2 FOR 1ST N-R GROUP, NNP2 + 5 FOR 2ND, ....
C ***    FOR EACH GROUP, 1 AND 2 ARE PHI-LAMBDA IN TWO PERP DIRECS,
C ***     AND 3,4,AND 5 ARE FOR PHI-TRANSL PARALLEL & IN 2 PERP DIRECS
C ***  K IS TALLY FOR PARAMETER NUMBER
C ***  J1 IS NO OF NON-RIGID GROUPS ATOM N IS IN
C ***  V5 COMES FROM SUBROUTINE DERNP, VIA COMMON/LOC/
C ***  FROM HERE ON, DERIVS CHANGED, BECAUSE MEANING CHANGED
      GO TO (30,40,50), I
   30 IF(I.NE.L) GO TO 34
C ***    THIS BRANCH FOR I = L = 1, THAT IS FOR U11 TERMS
      AO(K+1) =VAF(M,2)*2.0*AX(N,3)*V5(M,1)-VAF(M,3)*2.0*AX(N,2)*V5(M,1)
      AO(K+2) = PVEC(M,2)*2.0*AX(N,3)*V5(M,1)-2.0*PVEC(M,3)*AX(N,2)*V5(M
     1,1)
      AO(K+3) = VEC1(M,1)*2.0*V5(M,1)
      AO(K+4) = VAF(M,1)*2.0*V5(M,1)
      AO(K+5) = PVEC(M,1)*2.0*V5(M,1)
      GO TO 75
   34 IF(L.EQ.3) GO TO 37
C ***   I = 1, L = 2
      AO(K+1) = -VAF(M,1)*AX(N,3)*V5(M,1) + VAF(M,2)*AX(N,3)*V5(M,2) +
     1  VAF(M,3)*(AX(N,1)*V5(M,1) - AX(N,2)*V5(M,2))
      AO(K+2) =  -PVEC(M,1)*AX(N,3)*V5(M,1) + PVEC(M,2)*AX(N,3)*V5(M,2)
     1 + PVEC(M,3)*(AX(N,1)*V5(M,1) - AX(N,2)*V5(M,2))
      AO(K+3) = VEC1(M,1)*V5(M,2) + VEC1(M,2)*V5(M,1)
      AO(K+4) = VAF(M,1)*V5(M,2) + VAF(M,2)*V5(M,1)
      AO(K+5) = PVEC(M,1)*V5(M,2) + PVEC(M,2)*V5(M,1)
      GO TO 75
   37 AO(K+1) = VAF(M,1)*AX(N,2)*V5(M,1) + VAF(M,2)*(AX(N,3)*V5(M,3) -
     1 AX(N,1)*V5(M,1)) - VAF(M,3)*AX(N,2)*V5(M,3)
C ***  I = 1, L = 3
      AO(K+2) = PVEC(M,1)*AX(N,2)*V5(M,1) + PVEC(M,2)*(AX(N,3)*V5(M,3) -
     1  AX(N,1)*V5(M,1)) - PVEC(M,3)*AX(N,2)*V5(M,3)
      AO(K+3) = VEC1(M,1)*V5(M,3) + VEC1(M,3)*V5(M,1)
      AO(K+4) = VAF(M,1)*V5(M,3) + VAF(M,3)*V5(M,1)
      AO(K+5) = PVEC(M,1)*V5(M,3) + PVEC(M,3)*V5(M,1)
      GO TO 75
   40 IF(L.EQ.3) GO TO 45
C ***   I = 2, L = 2
      AO(K+1) = -2.0*(VAF(M,1)*AX(N,3)*V5(M,2)-VAF(M,3)*AX(N,1)*V5(M,2))
      AO(K+2) = -2.0*PVEC(M,1)*AX(N,3)*V5(M,2) +
     1  2.0*PVEC(M,3)*AX(N,1)*V5(M,2)
      AO(K+3) =  2.0*VEC1(M,2)*V5(M,2)
      AO(K+4) =  2.0*VAF(M,2)*V5(M,2)
      AO(K+5) =  2.0*PVEC(M,2)*V5(M,2)
      GO TO 75
   45 AO(K+1) = VAF(M,1)*(AX(N,2)*V5(M,2) - AX(N,3)*V5(M,3)) -
     1  VAF(M,2)*AX(N,1)*V5(M,2) + VAF(M,3)*AX(N,1)*V5(M,3)
C ***   I = 2, L = 3
      AO(K+2) = PVEC(M,1)*(AX(N,2)*V5(M,2) - AX(N,3)*V5(M,3))
     1  - PVEC(M,2)*AX(N,1)*V5(M,2) + PVEC(M,3)*AX(N,1)*V5(M,3)
      AO(K+3) =   VEC1(M,2)*V5(M,3) + VEC1(M,3)*V5(M,2)
      AO(K+4) =   VAF(M,2)*V5(M,3) + VAF(M,3)*V5(M,2)
      AO(K+5) =   PVEC(M,2)*V5(M,3) + PVEC(M,3)*V5(M,2)
      GO TO 75
   50 AO(K+1) = 2.0*(VAF(M,1)*AX(N,2)*V5(M,3)-VAF(M,2)*AX(N,1)*V5(M,3))
C ***   I = 3, L = 3
      AO(K+2) = 2.0*PVEC(M,1)*AX(N,2)*V5(M,3) -
     1   2.0*PVEC(M,2)*AX(N,1)*V5(M,3)
      AO(K+3) = VEC1(M,3)*2.0*V5(M,3)
      AO(K+4) =  VAF(M,3)*2.0*V5(M,3)
      AO(K+5) = PVEC(M,3)*2.0*V5(M,3)
   75 CONTINUE
   76 CONTINUE
      IF(J1.LE.1.OR.ICORL.GE.0) RETURN
C ***  INTERGROUP CORRELN INDETERMINATE WITH OVERALL/INTERNAL CORRELN
C *** FOLLOWING IS FOR CORRELATIONS OF PHI FOR DIFFERENT NR GROUPS IN
C ***   WHICH ATOM N IS INCLUDED.  J1 = 2 OR 3 (MAX IS 3)
C ***  IPAIR CREATED IN "SOLVE"
      M2 = 0
C ***   M2 IS AN INDICATOR OF WHERE ONE IS IN THIS LOOP
      M = IZ(1)
      MM = IZ(2)
   85 KK = IPAIR(M,MM)
      IF(KK.NE.0) GO TO 90
      WRITE(LO,200) ATNAME(N), N, M, MM
  200 FORMAT(1H ,'ERROR.  ATOM ',A4,' (NO.',I4,') SAID TO BE IN GROUPS',
     1 I3,' AND',I3,' BUT SOME ERROR IN SETTING UP IPAIR(I,J)')
      STOP
   90 AO(KK) = V5(M,I)*V5(MM,L) + V5(MM,I)*V5(M,L)
      IF(J1.EQ.2) RETURN
C ***  J1 = 3; THREE GROUPS COMMON TO ATOM N
      IF(M2.GE.1) GO TO 100
C ***  THIS PASS GIVES CROSS-TERMS BETW 1ST, 3RD GROUPS COMMON TO ATOM N
      M2 = M2 + 1
      MM = IZ(3)
      GO TO 85
  100 IF(M2.EQ.2) RETURN
      M = IZ(2)
C ***  THIS PASS GIVES CROSS-TERMS BETW 2ND, 3RD GROUPS COMMON TO ATOM N
      M2 = M2 + 1
      GO TO 85
      END
