      SUBROUTINE DIST(NTS)
C *** MODIFIED 17.IX.85 -- EARLIER VERSION CALCULATED DISTANCES FROM
C ***  EVERY ATOM GENERATED BY SYMMETRY, NOT JUST UNIQUE INPUT ATOMS
C ***  (ALTHOUGH IT SAID IT DID ONLY THE LATTER)
C  CALCULATES DISTANCES AND PRINTS THOSE SMALLER THAN  DIS  FROM EACH
C    ATOM IN INPUT UNIT TO EACH OTHER ATOM AND TO ALL GENERATED BY
C    SYMMETRY (EXCEPT THOSE AT ZERO DISTANCE, WHEN ATOM IS ON A
C    SYMMETRY ELEMENT)
C
      COMMON// AIDX(3000)
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/CONT1/ISET,NO, NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT,IOUT, IRECAL, IFREQ
      COMMON/INOUTN/NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
C
      DIMENSION D(4),AN1(4),AN2(4),NP2(4),X1(3),X2(3),IT(150),I0(150),
     1  I1(150),NP1(4),NB(12,12)
      EQUIVALENCE  (AIDX(1251), IT(1))
      EQUIVALENCE (AIDX(1400),I0(1)), (AIDX(1551),I1(1))
      CHARACTER*4 AN1,AN2
      CHARACTER*4 NAME1, ATNAME, TISET,TITLE*80, ITBL*3, NAME2*5
C
C   NTS IS NTOTS, THE TOTAL NUMBER OF ATOMS IN THE SYSTEM
C      (INCLUDING THOSE GENERATED BY SYMMETRY)
      DO 10 I = 1,NTS
      IT(I) = 0
      I0(I) = 0
      I1(I) = 0
   10 CONTINUE
      DO 15 I=1,12
      DO 15 J = 1,12
   15 NB(I,J) = 0
      CALL OUTH6
      WRITE(LO,2) DIS
    1 FORMAT(1X, 4(A4,1X,I2,2X,A4,1X,I2,2X,F5.3,6X))
    2 FORMAT(1H ,'DISTANCES SMALLER THAN ', F5.2,
     1 ', FROM INPUT ATOMS TO ALL ATOMS, INCLUDING ANY GENERATED BY SYMM
     2ETRY',/)
    3 FORMAT(1H )
    4 FORMAT(1X,'ATOM ',A4,', POSN ',I2,', HAS NO NEIGHBORS WITHIN',
     1 F5.2,' ANGSTROMS.')
    5 FORMAT(1X,'ATOM ',A4,', POSN ',I2,', HAS ONLY ONE NEIGHBOR WITHIN'
     1, F5.2,' ANGSTROMS.')
    6 FORMAT(1X,'UNIT',I3,' TO UNIT',I3)
    7 FORMAT(1H ,'PAIRS OF ASYMMETRIC UNITS WITH AT LEAST ONE INTER-UNIT
     1 INTERATOMIC DISTANCE SMALLER THAN ',F5.2,' ANGSTROMS:',/)
C
      K = 1
C**   I = NTS - 1
      J = 0
C  J IS TALLY FOR FIRST ATOM
   20 J = J + 1
        IF(J.GT.NTOT) GO TO 75
      M = J
   25 M = M + 1
C  M IS TALLY FOR SECOND ATOM, INCLUDING UNIQUE AND SYMMETRY-CREATED
      IF(M.GT.NTS) GO TO 20
      D(K) = SQRT((AX(J,1) - AX(M,1))**2 +(AX(J,2) - AX(M,2))**2
     1   + (AX(J,3) - AX(M,3))**2)
      IF(D(K).GE.DIS.OR.D(K).LT.0.0001) GO TO 25
      NJ = 1
      IJ = J
   35 IF(M.GT.NTOT) GO TO 40
      NM = 1
      IM = M
      GO TO 50
   40 NM = (M - NTOT - 1)/NA + 2
      IM = M - NTOT - NA*(NM-2)
   50 AN1(K) = ATNAME(IJ)
      NP1(K) = NJ
      AN2(K) = ATNAME(IM)
      NP2(K) = NM
      IT(J) = IT(J) + 1
      IT(M) = IT(M) + 1
      IF(NO.EQ.1.OR.NM.EQ.NJ.OR.NM.GT.12.OR.NJ.GT.12) GO TO 55
      NB(NM,NJ) = 1
      NB(NJ,NM) = 1
C   NB MARKS SHORT DISTANCES BETWEEN PAIRS OF ATOMS IN SYMMETRY
C     POSNS NM AND NJ FOR UP TO 12 SYM POSITIONS
   55 IF(K.LT.4) GO TO 90
      K = 1
      LL = 4
      GO TO 80
   75 LL = K - 1
   80 WRITE(LO,1) (AN1(L),NP1(L),AN2(L),NP2(L),D(L),L=1,LL)
      IF(J.GE.NTOT) GO TO 200
      GO TO 25
   90 K = K + 1
      GO TO 25
  200 WRITE(LO,3)
      N0 = 0
      N1 = 0
      DO 240 I = 1,NTOT
      IF(IT(I).EQ.0) GO TO 210
      GO TO 220
  210 N0 = N0 + 1
      I0(N0) = I
      GO TO 240
  220 IF(IT(I).EQ.1) GO TO 230
      GO TO 240
  230 N1 = N1 + 1
      I1(N1) = I
  240 CONTINUE
      IF(N0.EQ.0) GO TO 260
      DO 250 I = 1,N0
      N = 1
      K = I0(I)
  250 WRITE(LO,4) ATNAME(K),N,DIS
  260 CONTINUE
      IF(N1.EQ.0) GO TO 280
      DO 270 I = 1,N1
      N = 1
      K = I1(I)
  270 WRITE(LO,5) ATNAME(K),N,DIS
  280 CONTINUE
      IF(NO.EQ.1) GO TO 310
      WRITE(LO,7) DIS
      K = NMULT
      IF(K.GT.12) K = 12
      DO 300 I = 1,K
      DO 300 J = 1,K
      IF(NB(I,J).EQ.1) WRITE(LO,6) I,J
  300 CONTINUE
  310 CONTINUE
      RETURN
      END
