      SUBROUTINE EIGEN(A,V1,N)
C
C *** IN THIS VERSION, THE DIMENSION (N) IS IN THE CALLING STATEMENT
C     THE SUBROUTINE CAN HANDLE A N,N MATRIX BY ADJUSTING THE DIMENSIONS
C     AND STATEMENT NUMBER 1
C
C     THE DIAGONAL ELEMENTS OF THE REPLACED MATRIX A CONTAIN THE
C     EIGENVALUES WHICH ARE IN SEQUENCE A(1,1) A(2,2) A(3,3)
C     THE COLUMN J OF THE MATRIX V1 CONTAINS THE EIGENVECTOR BELONGING
C     TO THE EIGENVALUE A(J,J)
C
      DIMENSION V1(N,N),A(N,N)
C   1 N = 3
C ***  N IS NOW DEFINED IN THE CALLING STATEMENT
      DO 120 I = 1,N
      DO 120 J = 1,N
      IF ((I-J).NE.0) GO TO 110
      V1(I,J) = 1.
      GO TO 120
  110 V1(I,J) = 0.
  120 CONTINUE
      DO 360  K = 1,50
      SS = 0.
      NM1 = N - 1
      DO 170 I = 1,NM1
      IP1 = I + 1
      DO 170 J = IP1,N
      SS = SS + (A(I,J)**2)
      IF (K.GT.3)  GO TO 160
      TRESH = 0.2 * SQRT (2.0*SS)/N
      GO TO 170
  160 TRESH = 0.0
  170 CONTINUE
      DO 350 I = 1,NM1
      IP1 = I + 1
      DO 350 J = IP1,N
      IF ((A(I,J)**2).EQ.0.)  GO TO 200
      IF ((A(I,I) + A(I,J)).NE.A(I,I))  GO TO 220
      IF ((A(J,J) + A(I,J)).NE.A(J,J)) GO TO 220
  200 A(I,J) = 0.
      IF(A(I,I).GE.A(J,J)) GO TO 220
      C = 0.
      S = 1.
      GO TO 300
  220 CONTINUE
      IF(ABS (A(I,J)).LE.TRESH) GO TO 350
      THETA = 0.5 * (A(J,J)-A(I,I))/A(I,J)
      IF(ABS (THETA).LT.1.) GO TO 260
      IF((0.1/THETA/THETA).NE.0.)  GO TO 260
      S = 0.5 * THETA
      C = 1.
      GO TO 300
  260 T = ABS (THETA) + SQRT (1. + THETA**2)
      IF(THETA.LE.0.) GO TO 280
      T = 1./T
      GO TO 290
  280 T = -1./T
  290 C = 1./SQRT (1.+T**2)
      S = T*C
  300 D = (C*C*A(I,I)) - (2.*S*C*A(I,J)) + (S*S*A(J,J))
      A(J,J) = (S*S*A(I,I)) + (2.*S*C*A(I,J)) + (C*C*A(J,J))
      A(I,I) = D
      A(I,J) = 0.
      IM1 = I - 1
      IF (IM1 - 1) 410,311,311
  311 DO 310 KI = 1,IM1
      D = (C*A(KI,I)) - (S*A(KI,J))
      A(KI,J) = (S*A(KI,I)) + (C*A(KI,J))
      A(KI,I) = D
  310 CONTINUE
  410 JM1 = J - 1
      IF (IP1 - JM1) 321,321,420
  321 DO 320 KI=IP1,JM1
      D = (C*A(I,KI)) - (S*A(KI,J))
      A(KI,J) = (S*A(I,KI)) + (C*A(KI,J))
      A(I,KI) = D
  320 CONTINUE
  420 JP1 = J + 1
      IF (JP1 - N) 331,331,430
  331 DO 330 KI = JP1,N
      D = (C*A(I,KI)) - (S*A(J,KI))
      A(J,KI) = (S*A(I,KI)) + (C*A(J,KI))
      A(I,KI) = D
  330 CONTINUE
  430 DO 340 KI = 1,N
      D = (C*V1(KI,I)) - (S*V1(KI,J))
      V1(KI,J) = (S*V1(KI,I)) + (C*V1(KI,J))
      V1(KI,I) = D
  340 CONTINUE
      A(I,J) = 0.
  350 CONTINUE
      IF(SS.EQ.0.) GO TO 370
  360 CONTINUE
  370 RETURN
      END
