      SUBROUTINE LIBCOR
C ***  27.I  CALLED NOW ONLY WHEN NS.GE.0 OR IOUT.NE.0
C         MODIFIED MARCH 1982 TO PRINT CORRECTED DISTANCES (LT 'DISTA')
C             OCTOBER 1985 -- CORRD DISTANCES NOW CALCD IN 'DISCOR';
C                    NOW ONLY CORRECTED PARAMETERS CALCD, OUTPUT HERE
C     CALCULATES LIBRATION CORRECTIONS BY SCHOMAKER-TRUEBLOOD EQ 21. NO
C       Q**2 TERMS (CRUICKSHANK) USED; IN EFFECT ASSUME Q**2 INFINITE
C       (PEAKS BROAD RELATIVE TO OSCILLATIONS). SEE ALSO ACTA 17,142.
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),
     1  UCALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT,IOUT,IRECAL, IFREQ
      common/inerta/axi(150,3),auobsi(150,6)
      COMMON/INOUTN/ NPAGE, KOUTP,  DISTA, IAW
C *** WHAT IS INPUT AS "DIS" IS HERE CALLED "DISTA"
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3)
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
C
      DIMENSION AHL(3,3),DIS(4),AT1(4),AT2(4),WTT(150)
      DIMENSION PL(6),AL(3,3),W(3,3),DEL(3),AAX(3),AXX(150,3)
      EQUIVALENCE(AHL(1,1),AIDX(2601)),(WTT(1),AIDX(451))
      EQUIVALENCE (AXX(1,1),AIDX(1)),(AAX(1),AIDX(2685))
      EQUIVALENCE(W(1,1),AIDX(2671)),(DEL(1),AIDX(2681))
      EQUIVALENCE(PL(1),AIDX(2621)),(AL(1,1),AIDX(2661))
      CHARACTER*4  AT1,AT2
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
C
  200 FORMAT(1X,4(A4,2X,A4,2X,F6.3,10X))
C 210 FORMAT(1H ,'INTRAMOLECULAR DISTANCES AMONG INPUT ATOMS LESS THAN',
C    1 F6.3,' A, AFTER CORRECTION FOR OVERALL MOLECULAR MOTION,',/5X,
C    2 'BUT NOT FOR INTERNAL MOTION.  NOT INCLUDED:  ATOMS GENERATED BY
C    3SYMMETRY, ATOMS WITH WTS 800.0, 999.9, OR NEGATIVE.',/)
C
      DO 80 I = 1,3
      IF(AHL(I,I).EQ.0.)  RETURN
   80 CONTINUE
      TRAL = 0.
      CALL VMLT(PL,AL)
      DO 5 I = 1,3
      TRAL = TRAL + AL(I,I)
    5 CONTINUE
      DO 10 I = 1,3
      DO 10 J = 1,3
      W(I,J) = 0.5*(SYMOP(1,I,J)*TRAL - AL(I,J))
   10 CONTINUE
      DO 15 K = 1,NTOT
      DO 20 I = 1,3
      DEL(I) = 0.
      AAX(I) = AXi(K,I)
      DO 30 J = 1,3
      DEL(I) = DEL(I) + W(I,J)*AXi(K,J)
   30 CONTINUE
      AAX(I) = AAX(I) + DEL(I)
   20 CONTINUE
C          BACK-CORRECT FOR ORIGIN SHIFT OF AX(K,J) TO CENTER OF MASS
   60 DO 50 I = 1,3
      AXX(K,I) = SCG(I)
      DO 50 J = 1,3
      AXX(K,I) = AXX(K,I) + TCINVC(I,J)*AAX(J)
   50 CONTINUE
   15 CONTINUE
C     IF(NS.LT.0) GO TO 90  (SUBROUTINE NOT EVEN CALLED WHEN NS NEG)
      CALL OUTH6
      CALL OTHR21
      CALL OTHR14
C     PRINT ATOMIC COORDINATES BEFORE AND AFTER LIBRATION CORRECTION
      KOUTP = 4
      CALL OUTP15
   90 IF(IOUT.NE.0) CALL OUTR9
C     OUTPUT NEW COORDINATES ON UNIT 7
      RETURN
C ****  FOLLOWING SECTION USED EARLIER TO CALC AND PRINT CORRD DISTS
C
C**FOLLOWING CALCULATES CORRECTED DISTANCES LESS THAN 'DISTA' A BETWEEN
C**  INPUT ATOMS (NOT DUMMIES HOWEVER). NO DISTS TO SYM-RELD ATOMS.
C     WRITE(LO,210) DISTA
C     K = 1
C** K IS TALLY FOR DISTANCES TO BE PRINTED ON A SINGLE LINE
C     I = NA - 1
C     J = 0
C**J IS TALLY FOR FIRST ATOM
C 105 J = J + 1
C     IF(J.GT.I) GO TO 125
C     IF(WTT(J).EQ.800.0.OR.WTT(J).EQ.999.9) GO TO 105
C     M = J
C 110 M = M + 1
C** M IS TALLY FOR SECOND ATOM
C     IF(M.GT.NA) GO TO 105
C     IF(WTT(M).EQ.800.0.OR.WTT(M).EQ.999.9) GO TO 110
C     DO 115 N = 1,3
C     DEL(N) = AXX(J,N) - AXX(M,N)
C 115 CONTINUE
C     DDIS = 0.0
C     DO 120 N = 1,3
C     DO 120 L = 1,3
C     DDIS = DDIS + G(N,L)*DEL(N)*DEL(L)
C 120 CONTINUE
C     DIST = SQRT(DDIS)
C     IF(DIST.GE.DISTA) GO TO 110
C     DIS(K) = DIST
C     AT1(K) = ATNAME(J)
C     AT2(K) = ATNAME(M)
C     IF(K.LT.4) GO TO 135
C     K = 1
C     NN = 4
C     GO TO 130
C 125 NN = K - 1
C 130 WRITE(LO,200) (AT1(N),AT2(N),DIS(N), N = 1,NN)
C     IF(J.GT.I) RETURN
C     GO TO 110
C 135 K = K + 1
C     GO TO 110
      END
