      SUBROUTINE MATNVV(A,N,NA,M,B,DETER)
C  DOUBLE-PRECISION VERSION OF MATINV, CALLED BY SOLVE
C    (CHANGES MADE BY KNT IN MATINV, JUNE 1984)
C     N = SIZE OF THE SQUARE MATRIX A AND VECTOR B
C        N MUST BE NO LARGER THAN NA, DIMENSION OF A AND B (LINE 40042)
C        NA, THE DIMENSION OF A AND B, IS DEFINED IN THE CALLING PROGRAM
C     M = 0  MATRIX INVERSION ONLY
C     M = 1 MATRIX INVERSION AND SOLUTION OF LINEAR EQUATION
C     B = RIGHT HAND SIDE OF SYSTEM OF LINEAR EQUATIONS
C   RESULTS:
C     A CONTAINS INVERTED MATRIX  A**-1
C     B CONTAINS SOLUTIONS
C     BB IS TEMPORARY DOUBLE-PRECISION VERSION OF B
C     DETERM = DETERMINANT
C     DETER = DETERM WHEN RETURNED TO SOLVE
C     IF DETERM = 0.0, IT MEANS THAT LARGEST AVAILABLE ELEMENT BECAME
C        0.0 AND NO RELIABLE RESULTS OBTAINED
C
      COMMON//AIDX(3000)
      COMMON/IAID1/IAIDX1(1000)
C     MATINV USES FOR MAX. DIMENSIONS OF MATRIX
C     COMMON// AIDX(801-880,1301-1540)  AND /IAID1/IAIDX1(360 - 439)
C     DUM = B   IN AIDX(801 - 880)
      DIMENSION IPIVOT(80), INDEX(80,2), PIVOT(80), BB(80)
      DIMENSION A(NA,NA),B(NA)
      EQUIVALENCE (IAIDX1(360),IPIVOT(1)),(AIDX(1381),INDEX(1,1))
      DOUBLE PRECISION  A,AMAX,AH,SWAP,PIVOT,DETERM,T,BB
C
C     INITIALIZATION
C
      DETERM=1.0
      DO 20 J=1,N
      BB(J) = B(J)
   20 IPIVOT(J)=0
      DO 550 I=1,N
C
C     SEARCH FOR PIVOT ELEMENT
      AMAX=0.0
      DO 105 J=1,N
      IF(IPIVOT(J).EQ.1)  GO TO 105
      DO 100 K = 1,N
      IF(IPIVOT(K).EQ.1)  GO TO 100
      IF(IPIVOT(K).GT.1)  GO TO 740
      AH = ABS(AMAX) - ABS(A(J,K))
      IF(AH.GE.0.)  GO TO 100
      IROW = J
      ICOLUM=K
      AMAX=A(J,K)
  100 CONTINUE
  105 CONTINUE
       IF (AMAX)110,800,110
  110 IPIVOT(ICOLUM)=IPIVOT(ICOLUM)+1
C
C     INTERCHANGE ROWS TO PUT PIVOT ELEMENT ON DIAGONAL
C
      IF (IROW-ICOLUM) 140, 260, 140
  140 DETERM=-DETERM
      DO 200 L=1,N
      SWAP=A(IROW,L)
      A(IROW,L)=A(ICOLUM,L)
  200 A(ICOLUM,L)=SWAP
      IF (M.EQ.0)  GO TO 260
      SWAP=BB(IROW)
      BB(IROW) = BB(ICOLUM)
      BB(ICOLUM) = SWAP
  260 INDEX(I,1)=IROW
      INDEX(I,2)=ICOLUM
      PIVOT(I)=A(ICOLUM,ICOLUM)
      DETERM=DETERM*PIVOT(I)
C
C     DIVIDE PIVOT ROW BY PIVOT ELEMENT
C
      A(ICOLUM,ICOLUM)=1.0
      DO 350 L=1,N
  350 A(ICOLUM,L)=A(ICOLUM,L)/PIVOT(I)
      IF (M.NE.0)  BB(ICOLUM) =BB(ICOLUM)/PIVOT(I)
C
C     REDUCE NON-PIVOT ROWS
C
      DO 550 L1=1,N
      IF(L1-ICOLUM) 400, 550, 400
  400 T=A(L1,ICOLUM)
      A(L1,ICOLUM)=0.0
      DO 450 L=1,N
  450 A(L1,L)=A(L1,L)-A(ICOLUM,L)*T
      IF (M.NE.0)  BB(L1) = BB(L1) - BB(ICOLUM)*T
  550 CONTINUE
C
C     INTERCHANGE COLUMNS
C
      DO 710 I=1,N
      L=N+1-I
      IF (INDEX(L,1)-INDEX(L,2)) 630, 710, 630
  630 JROW=INDEX(L,1)
      JCOLUM=INDEX(L,2)
      DO 705 K=1,N
      SWAP=A(K,JROW)
      A(K,JROW)=A(K,JCOLUM)
      A(K,JCOLUM)=SWAP
  705 CONTINUE
  710 CONTINUE
  740 DO 750 I = 1,N
      B(I) = BB(I)
  750 CONTINUE
      DETER = DETERM
      RETURN
  800 DETER=0.0
      RETURN
      END
