      SUBROUTINE NPAR
C
C     PRINT SYMMETRY OPERATIONS AND, FOR TRICLINIC, MONOCLINIC, AND
C     ORTHORHOMBIC POINT GROUPS, DETERMINE THE NUMBER OF INDEPENDENT
C     PARAMETERS AND SET UP LIST OF CONSTRAINTS FOR PARAMETERS.  FOR THE
C     HIGHER-SYMMETRY POINT GROUPS, THIS IS DONE IN SYMET NOW.
C
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(20),TITLE,ITBL(29),NAME2
      COMMON/IPAR/ NP(80)
C * * Make common IO assignments.
      COMMON/IOSET/LI,LO,LTB
      DIMENSION AIDS(48,3,3),DET(48),SMA(3,3),TMA(3,3),TNEW(3,3)
      DIMENSION SNEW(3,3),AH(9),NNP(9)
      EQUIVALENCE (AIDS(1,1,1),AIDX(2001)),(DET(1),AIDX(2501))
      EQUIVALENCE (SMA(1,1),AIDX(2951)),(TMA(1,1),AIDX(2961))
      EQUIVALENCE (TNEW(1,1),AIDX(2971)),(SNEW(1,1),AIDX(2980))
      EQUIVALENCE (AH(1),AIDX(2991))
      EQUIVALENCE (NNP(1),IAIDX1(481))
      CHARACTER*4 NAME1,ATNAME,TISET,TITLE*80, ITBL*3, NAME2*5
C
      EPS = 0.00001
      IF (NO.GE.75) GO TO 615
C          FOR GROUPS WITH MORE THAN 2-FOLD SYMMETRY ELEMENTS, THE
C         CONSTRAINTS ARE SET AND THE PARAMETERS COUNTED IN SYMET NOW.
      DO 100 I=1,21
  100 NP(I) = I
    1 DO 10 I=1,3
      SI = FLOAT(I)*10.
      DO 10 J=1,3
   10 SMA(I,J) = SI + FLOAT(J)
      DO 20 I=1,3
      SI = FLOAT(I)*10
      DO 20 J=I,3
      TMA(J,I) = SI + FLOAT(J)
   20 TMA(I,J) = TMA(J,I)
      DO 25 I=1,3
      DO 25 J=1,3
      TNEW(I,J) = 0.
      SNEW(I,J) = 0.
   25 CONTINUE
      DO 30 NSY = 1,NMULT
      DO 130 I = 1,3
      DO 130 J = I,3
      SUMT = 0.
      DO 40 K=1,3
      DO 40 L=1,3
      SSYM = AIDS(NSY,I,K)*AIDS(NSY,J,L)
   40 SUMT = SUMT + SSYM*TMA(K,L)
      TNEW(I,J) = TNEW(I,J) + SUMT
  130 TNEW(J,I) = TNEW(I,J)
      DO 135 I = 1,3
      DO 135 J = 1,3
      SUMS = 0.
      DO 45 K=1,3
      DO 45 L=1,3
      SSYM = AIDS(NSY,I,K)*AIDS(NSY,J,L)
   45 SUMS = SUMS + SSYM*DET(NSY)*SMA(K,L)
  135 SNEW(I,J) = SNEW(I,J) + SUMS
   30 CONTINUE
      DO 50 I=1,3
      DO 50 J=1,3
      TMA(I,J)  = TNEW(I,J)/NMULT
   50 SMA(I,J)  = SNEW(I,J)/NMULT
      NPULT = 0
      NPARS = 0
      DO 210 I = 1,3
      DO 210 K=I,3
      IF (TMA(I,K).EQ.0.)  GO TO 210
      NPULT = NPULT + 1
  210 CONTINUE
      DO 220 I = 1,3
      DO 220 K = 1,3
      IF (SMA(I,K).EQ.0.)  GO TO 220
      NPARS = NPARS + 1
  220 CONTINUE
      IF (NPARS.GT.4)  NPARS = NPARS - 1
C     POINT GROUP SYMMETRIES C1 AND C2  AMBIGUITY IN DIAGONAL OF S
C     REDUCTION OF NUMBER OF INDEPENDENT PARAMETERS
      IF(NO.EQ.1) GO TO 200
      IF(NO.NE.2) GO TO 300
  200 NINPAR = 2*NPULT + NPARS
      IF(NO.EQ.2) GO TO 620
      IF(NO.EQ.1) GO TO 620
C        FOLLOWING SECTION (DOWN TO 615) IS NOW USED ONLY FOR POINT-
C         GROUP SYMMETRIES CORRESPONDING TO MONOCLINIC AND ORTHO-
C         RHOMBIC SPACE GROUPS, ALTHOUGH LOGIC REMAINS THAT OF THE
C         EARLIER VERSION (SOME NOT NOW NEEDED FOR USUAL SETTINGS OF
C         THE PRINCIPAL AXIS).
  300 I2 = 6
      DO 310 I = 1,3
  310 AH(I) = TMA(1,I)
      DO 320 I = 4,5
  320 AH(I) = TMA(2,I-2)
      AH(6) = TMA(3,3)
  325 DO 330 I = 1,I2
  330 NNP(I) = I
      DO 345 J = 1,I2
      I1 = J + 1
      AAH = ABS(AH(J))
      IF(AAH.LE.EPS)  GO TO 340
      SAH = AH(J)
      NSAH = NNP(J)
      GO TO 335
  340 NNP(J) = 0
  345 CONTINUE
  335 IF(J.GE.I2)  GO TO 350
  360 IKH = 1
      DO 355 I = I1,I2
      AAH = ABS(AH(I))
      IF(AAH.LE.EPS)  GO TO 380
      AAH = ABS(AH(I)-SAH)
      IF(AAH.LE.EPS)  GO TO 390
      AAH = ABS(AH(I)+SAH)
      IF(AAH.GT.EPS)  GO TO 355
      IKH = - 1
  390 IF(ISET.EQ.3)  GO TO 370
      IF(ISET.GT.3)  GO TO 365
  395 NNP(I) = IKH * NSAH
      GO TO 355
  370 IF(NO.GE.195)  GO TO 395
      IF(I2.EQ. 6)  GO TO 410
      IF(I .EQ. 5)  GO TO 355
      IT = I1 - 1
      IF(IT.EQ. 5)  GO TO 355
      GO TO 395
  410 IF(I.EQ.4)  GO TO 355
      GO TO 395
  365 IF(I2.EQ.9)  GO TO 375
      IT = I1 - 1
      IF(IT.EQ.1)  GO TO 366
      IF(IT.EQ.4)  GO TO 366
C     TEST FOR DIAGONAL ELEMENTS
      IF(I .EQ.4)  GO TO 355
      IF(I .EQ.6)  GO TO 355
      GO TO 395
  366 IF(I .EQ.4)  GO TO 395
      IF(I .EQ.6)  GO TO 395
      GO TO 355
  375 IT = I1 - 1
C     TEST FOR DIAGONAL ELEMENTS
      IF(IT.EQ.1)  GO TO 376
      IF(IT.EQ.5)  GO TO 376
      IF(I .EQ.5)  GO TO 355
      IF(I .EQ.9)  GO TO 355
      GO TO 395
  376 IF(I .EQ.5)  GO TO 395
      IF(I .EQ.9)  GO TO 395
      GO TO 355
  380 NNP(I) = 0
  355 CONTINUE
      SAH = AH(I1)
      NSAH = NNP(I1)
      I1 = I1 + 1
      IF(I1.NE.I2)  GO TO 360
  350 IF(I2.EQ.9)  GO TO 470
      DO 450 I = 1,I2
      IC = 0
      NP(I) = NNP(I)
      IF(NNP(I).EQ.0)  GO TO 460
      NHP = IABS(NNP(I)) + 6
      NP(I+6) = ISIGN(NHP,NNP(I))
      GO TO 450
  460 NP(I+6) = 0
  450 CONTINUE
      GO TO 500
  470 DO 480 I = 1,I2
      IC = 1
      IF(NNP(I).EQ.0)  GO TO 490
      NHP = IABS(NNP(I)) + 12
      NP(I+12) = ISIGN(NHP,NNP(I))
      GO TO 480
  490 NP(I+12) = 0
  480 CONTINUE
      CALL CNTPAR
      GO TO 620
  500 I2 = 9
      DO 590 I = 1,3
  590 AH(I) = SMA(1,I)
      DO 600 I = 1,3
  600 AH(I + 3) = SMA(2,I)
      DO 610 I = 1,3
  610 AH(I + 6) = SMA(3,I)
      GO TO 325
  615 NINPAR = 2*NPULT + NPARS
C     PRINT NAME1,NAME2,NA, NINOBS, NINPAR
  620 IF(NS.EQ.(-3).OR.NS.GT.(-2)) CALL OUTP3
      CALL ORTHO
      CALL INERT
      RETURN
      END
